"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var chalk = require("chalk");
var ora = require("ora");
var pkg = require('../package.json');
function authenticate(egghead, email, password) {
    return __awaiter(this, void 0, void 0, function () {
        var spinner;
        return __generator(this, function (_a) {
            spinner = createSpinner('Authenticating...');
            return [2 /*return*/, egghead
                    .authenticate({ email: email, password: password })
                    .then(function () {
                    spinner.succeed('Authenticated');
                    console.log();
                }, function (err) {
                    spinner.fail();
                    console.log();
                    return handleErrorAndExit(err);
                })];
        });
    });
}
exports.authenticate = authenticate;
function extendSpinner(spinner) {
    return spinner;
}
function createSpinner(text) {
    return extendSpinner(ora({
        text: text,
        color: 'yellow',
        interval: 25
    }).start());
}
exports.createSpinner = createSpinner;
function displayCredentialsNotSet() {
    console.log(chalk.red("Email and/or password have not been set."));
    console.log('');
    console.log("Please set using: ");
    console.log('');
    console.log("  " + pkg.name + " config -e <email> -p <password>");
    console.log();
}
exports.displayCredentialsNotSet = displayCredentialsNotSet;
function displayDownloadPathNotSet() {
    console.log(chalk.red('Download path has not been set.'));
    console.log();
    console.log('Please set using: ');
    console.log();
    console.log("  " + pkg.name + " config -d <download-path>");
    console.log();
}
exports.displayDownloadPathNotSet = displayDownloadPathNotSet;
function downloadTechnology(technology) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            throw new Error('Not Yet Implemented');
        });
    });
}
exports.downloadTechnology = downloadTechnology;
function downloadCourse(course) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            throw new Error('Not Yet Implemented');
        });
    });
}
exports.downloadCourse = downloadCourse;
function downloadLesson() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            throw new Error('Not Yet Implemented');
        });
    });
}
exports.downloadLesson = downloadLesson;
function handleErrorAndExit(err) {
    console.log(chalk.red(err.message || err));
    process.exit(1);
    throw null;
}
exports.handleErrorAndExit = handleErrorAndExit;
function getCourses(egghead) {
    return __awaiter(this, void 0, void 0, function () {
        var spinner;
        return __generator(this, function (_a) {
            spinner = createSpinner('Retrieving course information...');
            return [2 /*return*/, egghead.getCourses().then(function (technologies) {
                    spinner.succeed('Retrieved course information');
                    console.log();
                    return technologies;
                }, function (err) {
                    spinner.fail();
                    console.log();
                    return handleErrorAndExit(err);
                })];
        });
    });
}
exports.getCourses = getCourses;
function getFieldNamesInType(objectWithFieldNames) {
    var result = Object.getOwnPropertyNames(objectWithFieldNames);
    return result;
}
exports.getFieldNamesInType = getFieldNamesInType;
function getSubsetOfObject(data, fieldNames) {
    var result = {};
    for (var _i = 0, fieldNames_1 = fieldNames; _i < fieldNames_1.length; _i++) {
        var fieldName = fieldNames_1[_i];
        result[fieldName] = data[fieldName];
    }
    return result;
}
exports.getSubsetOfObject = getSubsetOfObject;
//# sourceMappingURL=common.js.map