"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var requestPromise = require("request-promise");
var cheerio = require("cheerio");
var fs = require("mz/fs");
var rss_1 = require("./utils/rss");
var URLS = {
    LOGIN: 'https://egghead.io/users/sign_in',
    COURSES: 'https://egghead.io/courses',
    COURSE_FEED_URL: 'https://egghead.io/courses/{courseCode}/course_feed?user_email={email}&user_token={userToken}',
    MEMBERSHIP: 'https://egghead.io/membership'
};
var CsrfTokenNotFound = (function (_super) {
    __extends(CsrfTokenNotFound, _super);
    function CsrfTokenNotFound() {
        return _super.call(this, 'Authentication Failed: Could not find Cross-site Request Forgery token') || this;
    }
    return CsrfTokenNotFound;
}(Error));
exports.CsrfTokenNotFound = CsrfTokenNotFound;
var NotAuthenticated = (function (_super) {
    __extends(NotAuthenticated, _super);
    function NotAuthenticated() {
        return _super.call(this, 'Not authenticated') || this;
    }
    return NotAuthenticated;
}(Error));
exports.NotAuthenticated = NotAuthenticated;
var noop = function () { };
var EggHead = (function () {
    function EggHead() {
        this.authenticatedWithCredentials = null;
    }
    EggHead.prototype.isAuthenticated = function () {
        return !!this.authenticatedWithCredentials;
    };
    EggHead.prototype.authenticate = function (credentials) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var options;
            return __generator(this, function (_a) {
                this.authenticatedWithCredentials = null;
                this.request = requestPromise.defaults(EggHead.defaultOptionsForRequest);
                options = {
                    url: URLS.LOGIN,
                    headers: {
                        'Accept': '*/*',
                        'Accept-Encoding': 'gzip, deflate, br',
                        'Accept-Language': 'en-GB,en-US;q=0.8,en;q=0.6',
                        'Cache-Control': 'max-age=0',
                        'Connection': 'keep-alive',
                        'Content-Type': 'application/x-www-form-urlencoded',
                        'Origin': 'https://egghead.io',
                        'Referer': 'https://egghead.io/users/sign_in',
                        'Upgrade-Insecure-Requests': '1'
                    }
                };
                return [2 /*return*/, this.request
                        .get({
                        url: URLS.LOGIN,
                        transform: function (body) { return cheerio.load(body); },
                        transform2xxOnly: true
                    })
                        .then(function ($) {
                        var csrfToken = $('meta[name="csrf-token"]').attr('content') || '';
                        if (!csrfToken) {
                            throw new CsrfTokenNotFound();
                        }
                        return _this.request
                            .post(URLS.LOGIN, {
                            json: true,
                            form: {
                                'authenticity_token': csrfToken,
                                'user[email]': credentials.email,
                                'user[password]': credentials.password,
                                'utf8': '✓'
                            }
                        }).then(function () {
                            return _this.request.get({
                                url: URLS.MEMBERSHIP,
                                transform: function (body) { return cheerio.load(body); },
                                transform2xxOnly: true
                            }).then(function ($) {
                                var userToken = $('input#tech-token').val();
                                _this.authenticatedWithCredentials = __assign({}, credentials, { userToken: userToken });
                            });
                        });
                    })];
            });
        });
    };
    EggHead.prototype.downloadFile = function (url, fileName, progress) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var req = _this.request.get(url);
            var outputStream = fs.createWriteStream(fileName);
            var total;
            var downloaded = 0;
            var errored = false;
            req.on('response', function (response) {
                total = parseInt(response.headers['content-length'], 10);
            });
            req.on('data', function (chunk) {
                downloaded += chunk.length;
                if (progress) {
                    progress.update(downloaded, total);
                }
            });
            req.on('error', function (err) {
                errored = true;
                reject(err);
            });
            req.on('end', function () {
                if (!errored) {
                    if (progress) {
                        progress.update(downloaded, total);
                    }
                    resolve();
                }
            });
            req.pipe(outputStream);
        });
    };
    EggHead.prototype.getCourses = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var progressUpdate;
            return __generator(this, function (_a) {
                if (!this.authenticatedWithCredentials) {
                    throw new NotAuthenticated();
                }
                progressUpdate = function (progress, total) {
                    if (options && options.progress && options.progress.update) {
                        options.progress.update(progress, total);
                    }
                };
                return [2 /*return*/, this.request
                        .get({
                        url: URLS.COURSES,
                        transform: function (body) { return cheerio.load(body); },
                        transform2xxOnly: true
                    })
                        .then(function ($) {
                        var $technologies = $('.jump-into-technologies .technologies-list .item-wrapper');
                        var technologies = [];
                        var compareStrings = function (a, b) { return a.localeCompare(b); };
                        $technologies.each(function (index, technologyElement) {
                            var technology = {
                                name: $(technologyElement).find('.title').text().trim(),
                                courses: []
                            };
                            var technologyCodeName = $(technologyElement).find('a.anchor-to-technology').attr('data-technology');
                            var $courses = $("#technology-" + technologyCodeName).find('.card-course .card-content');
                            progressUpdate(0, $courses.length);
                            $courses.each(function (index, courseElement) {
                                var codeRegEx = /.*egghead.io\/courses\/(.+)/i;
                                var courseUrl = $(courseElement).find('a.link-overlay').attr('href');
                                var codeMatch = codeRegEx.exec(courseUrl);
                                var course = {
                                    name: $(courseElement).find('.course-title').text().trim(),
                                    code: (codeMatch && codeMatch[1]) || '',
                                    url: $(courseElement).find('a.link-overlay').attr('href'),
                                    lessonCount: parseInt($(courseElement).find('.lessons-in-course-number-holder .total').text().trim())
                                };
                                technology.courses.push(course);
                            });
                            technology.courses.sort(function (a, b) { return compareStrings(a.name, b.name); });
                            technologies.push(technology);
                            progressUpdate(technologies.length, $technologies.length);
                        });
                        return technologies.sort(function (a, b) { return compareStrings(a.name, b.name); });
                    })];
            });
        });
    };
    EggHead.prototype.getCourseFeedUrl = function (course) {
        if (!this.authenticatedWithCredentials) {
            throw new NotAuthenticated();
        }
        return URLS.COURSE_FEED_URL
            .replace('courseCode', course.code)
            .replace('email', this.authenticatedWithCredentials.email)
            .replace('userToken', this.authenticatedWithCredentials.userToken);
    };
    EggHead.prototype.getLessonUrl = function (courseCode) {
        if (!this.authenticatedWithCredentials) {
            throw new NotAuthenticated();
        }
        var url = "https://egghead.io/courses/" + courseCode + "/course_feed" +
            ("?user_email=" + this.authenticatedWithCredentials.email) +
            ("&user_token=" + this.authenticatedWithCredentials.userToken);
        return url;
    };
    EggHead.prototype.getCourseLessons = function (courseCode) {
        return __awaiter(this, void 0, void 0, function () {
            var url;
            return __generator(this, function (_a) {
                url = this.getLessonUrl(courseCode);
                return [2 /*return*/, rss_1.downloadAndParseRss(url).then(function (rssItems) {
                        var result = rssItems.map(function (rssItem, index) { return ({
                            name: rssItem.title || '',
                            url: (rssItem.enclosures && rssItem.enclosures.length && rssItem.enclosures[0].url) || '',
                            lessonNumber: index + 1
                        }); });
                        return result;
                    })];
            });
        });
    };
    return EggHead;
}());
EggHead.defaultOptionsForRequest = Object.freeze({
    jar: true,
    gzip: true,
    followRedirect: true,
    followAllRedirects: true,
    headers: {
        'Accept': '*/*',
        'Accept-Language': 'en-GB,en-US;q=0.8,en;q=0.6',
        'User-Agent': 'User-Agent: Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.87 Safari/537.36'
    }
});
exports.EggHead = EggHead;
//# sourceMappingURL=egghead.js.map